Bug 82660

Summary: Frequent crashes in JSC::parse in a worker thread when running regression tests
Product: WebKit Reporter: Enrica Casucci <enrica>
Component: JavaScriptCoreAssignee: Michael Saboff <msaboff>
Status: RESOLVED FIXED    
Severity: Normal CC: ap, benjamin, ggaren, msaboff, webkit-bug-importer
Priority: P2 Keywords: InRadar, MakingBotsRed
Version: 528+ (Nightly build)   
Hardware: Unspecified   
OS: Unspecified   
Attachments:
Description Flags
Patch
ggaren: review-
Updated patch
ggaren: review-
Updated Patch
none
Final Patch none

Description Enrica Casucci 2012-03-29 14:36:19 PDT
This crash happens intermittently on the test bots, mostly when running fast/workers/empty-worker-nocrash.html.
In a debug build fast/workers/shared-worker-constructor.html hits an ASSERT every single time. I think that the two problems are related.
Here is the crash log.

Process:         DumpRenderTree [83126]
Path:            /Volumes/VOLUME/*/DumpRenderTree
Identifier:      DumpRenderTree
Version:         ??? (???)
Code Type:       X86-64 (Native)
Parent Process:  Python [81663]

Date/Time:       2012-03-29 13:38:13.721 -0700
OS Version:      Mac OS X 10.7.3 (11D50)
Report Version:  9

Crashed Thread:  11  WebCore: Worker

Exception Type:  EXC_BAD_ACCESS (SIGSEGV)
Exception Codes: KERN_INVALID_ADDRESS at 0x0000000000000018

VM Regions Near 0x18:
--> 
    __TEXT                 000000010b081000-000000010b0d9000 [  352K] r-x/rwx SM=COW  /Volumes/VOLUME/*

Application Specific Information:
objc[83126]: garbage collection is OFF

Thread 0:: Dispatch queue: com.apple.main-thread
0   libsystem_kernel.dylib        	0x00007fff8f2ad67a mach_msg_trap + 10
1   libsystem_kernel.dylib        	0x00007fff8f2acd71 mach_msg + 73
2   libsystem_kernel.dylib        	0x00007fff8f29fd84 mach_port_insert_member + 131
3   com.apple.CoreFoundation      	0x00007fff900f3e00 __CFRunLoopRun + 1104
4   com.apple.CoreFoundation      	0x00007fff900f3676 CFRunLoopRunSpecific + 230
5   com.apple.Foundation          	0x00007fff89639f9f -[NSRunLoop(NSRunLoop) runMode:beforeDate:] + 267
6   DumpRenderTree                	0x000000010b08eb42 _ZL7runTestRKNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE + 1793 (DumpRenderTree.mm:1356)
7   DumpRenderTree                	0x000000010b08e214 dumpRenderTree(int, char const**) + 1848 (DumpRenderTree.mm:818)
8   DumpRenderTree                	0x000000010b08eee1 main + 86 (DumpRenderTree.mm:905)
9   DumpRenderTree                	0x000000010b083514 start + 52

Thread 1:: Dispatch queue: com.apple.libdispatch-manager
0   libsystem_kernel.dylib        	0x00007fff8f2af7e6 kevent + 10
1   libdispatch.dylib             	0x00007fff8cdf05be _dispatch_mgr_invoke + 923
2   libdispatch.dylib             	0x00007fff8cdef14e _dispatch_mgr_thread + 54

Thread 2:
0   libsystem_kernel.dylib        	0x00007fff8f2af192 __workq_kernreturn + 10
1   libsystem_c.dylib             	0x00007fff85f5e594 _pthread_wqthread + 758
2   libsystem_c.dylib             	0x00007fff85f5fb85 start_wqthread + 13

Thread 3:
0   libsystem_kernel.dylib        	0x00007fff8f2af192 __workq_kernreturn + 10
1   libsystem_c.dylib             	0x00007fff85f5e594 _pthread_wqthread + 758
2   libsystem_c.dylib             	0x00007fff85f5fb85 start_wqthread + 13

Thread 4:: com.apple.NSURLConnectionLoader
0   libsystem_kernel.dylib        	0x00007fff8f2ad67a mach_msg_trap + 10
1   libsystem_kernel.dylib        	0x00007fff8f2acd71 mach_msg + 73
2   com.apple.CoreFoundation      	0x00007fff900eb6fc __CFRunLoopServiceMachPort + 188
3   com.apple.CoreFoundation      	0x00007fff900f3e64 __CFRunLoopRun + 1204
4   com.apple.CoreFoundation      	0x00007fff900f3676 CFRunLoopRunSpecific + 230
5   com.apple.Foundation          	0x00007fff89693ffb +[NSURLConnection(NSURLConnectionReallyInternal) _resourceLoadLoop:] + 335
6   com.apple.Foundation          	0x00007fff8968874e -[NSThread main] + 68
7   com.apple.Foundation          	0x00007fff896886c6 __NSThread__main__ + 1575
8   libsystem_c.dylib             	0x00007fff85f5c8bf _pthread_start + 335
9   libsystem_c.dylib             	0x00007fff85f5fb75 thread_start + 13

Thread 5:
0   libsystem_kernel.dylib        	0x00007fff8f2af192 __workq_kernreturn + 10
1   libsystem_c.dylib             	0x00007fff85f5e594 _pthread_wqthread + 758
2   libsystem_c.dylib             	0x00007fff85f5fb85 start_wqthread + 13

Thread 6:: JavaScriptCore::Marking
0   libsystem_kernel.dylib        	0x00007fff8f2aebca __psynch_cvwait + 10
1   libsystem_c.dylib             	0x00007fff85f60274 _pthread_cond_wait + 840
2   com.apple.JavaScriptCore      	0x000000010b3034a4 JSC::SlotVisitor::drainFromShared(JSC::SlotVisitor::SharedDrainMode) + 212 (MarkStack.cpp:423)
3   com.apple.JavaScriptCore      	0x000000010b303386 JSC::MarkStackThreadSharedData::markingThreadMain() + 214 (MarkStack.cpp:226)
4   com.apple.JavaScriptCore      	0x000000010b3e820f _ZN3WTFL19wtfThreadEntryPointEPv + 15 (ThreadingPthreads.cpp:162)
5   libsystem_c.dylib             	0x00007fff85f5c8bf _pthread_start + 335
6   libsystem_c.dylib             	0x00007fff85f5fb75 thread_start + 13

Thread 7:: JavaScriptCore::Marking
0   libsystem_kernel.dylib        	0x00007fff8f2aebca __psynch_cvwait + 10
1   libsystem_c.dylib             	0x00007fff85f60274 _pthread_cond_wait + 840
2   com.apple.JavaScriptCore      	0x000000010b3034a4 JSC::SlotVisitor::drainFromShared(JSC::SlotVisitor::SharedDrainMode) + 212 (MarkStack.cpp:423)
3   com.apple.JavaScriptCore      	0x000000010b303386 JSC::MarkStackThreadSharedData::markingThreadMain() + 214 (MarkStack.cpp:226)
4   com.apple.JavaScriptCore      	0x000000010b3e820f _ZN3WTFL19wtfThreadEntryPointEPv + 15 (ThreadingPthreads.cpp:162)
5   libsystem_c.dylib             	0x00007fff85f5c8bf _pthread_start + 335
6   libsystem_c.dylib             	0x00007fff85f5fb75 thread_start + 13

Thread 8:: JavaScriptCore::Marking
0   libsystem_kernel.dylib        	0x00007fff8f2aebca __psynch_cvwait + 10
1   libsystem_c.dylib             	0x00007fff85f60274 _pthread_cond_wait + 840
2   com.apple.JavaScriptCore      	0x000000010b3034a4 JSC::SlotVisitor::drainFromShared(JSC::SlotVisitor::SharedDrainMode) + 212 (MarkStack.cpp:423)
3   com.apple.JavaScriptCore      	0x000000010b303386 JSC::MarkStackThreadSharedData::markingThreadMain() + 214 (MarkStack.cpp:226)
4   com.apple.JavaScriptCore      	0x000000010b3e820f _ZN3WTFL19wtfThreadEntryPointEPv + 15 (ThreadingPthreads.cpp:162)
5   libsystem_c.dylib             	0x00007fff85f5c8bf _pthread_start + 335
6   libsystem_c.dylib             	0x00007fff85f5fb75 thread_start + 13

Thread 9:: JavaScriptCore::BlockFree
0   libsystem_kernel.dylib        	0x00007fff8f2aebca __psynch_cvwait + 10
1   libsystem_c.dylib             	0x00007fff85f60274 _pthread_cond_wait + 840
2   com.apple.JavaScriptCore      	0x000000010b3e8816 WTF::ThreadCondition::timedWait(WTF::Mutex&, double) + 118 (ThreadingPthreads.cpp:415)
3   com.apple.JavaScriptCore      	0x000000010b26765f JSC::Heap::blockFreeingThreadMain() + 191 (Heap.cpp:399)
4   com.apple.JavaScriptCore      	0x000000010b3e820f _ZN3WTFL19wtfThreadEntryPointEPv + 15 (ThreadingPthreads.cpp:162)
5   libsystem_c.dylib             	0x00007fff85f5c8bf _pthread_start + 335
6   libsystem_c.dylib             	0x00007fff85f5fb75 thread_start + 13

Thread 10:
0   libsystem_kernel.dylib        	0x00007fff8f2af192 __workq_kernreturn + 10
1   libsystem_c.dylib             	0x00007fff85f5e594 _pthread_wqthread + 758
2   libsystem_c.dylib             	0x00007fff85f5fb85 start_wqthread + 13

Thread 11 Crashed:: WebCore: Worker
0   com.apple.JavaScriptCore      	0x000000010b260a6c WTF::PassRefPtr<JSC::ProgramNode> JSC::parse<JSC::ProgramNode>(JSC::JSGlobalData*, JSC::JSGlobalObject*, JSC::SourceCode const&, JSC::FunctionParameters*, JSC::JSParserStrictness, JSC::JSParserMode, JSC::Debugger*, JSC::ExecState*, JSC::JSObject**) + 60 (StringImpl.h:287)
1   com.apple.JavaScriptCore      	0x000000010b25f30e JSC::ProgramExecutable::compileInternal(JSC::ExecState*, JSC::ScopeChainNode*, JSC::JITCode::JITType) + 494 (PassRefPtr.h:161)
2   com.apple.JavaScriptCore      	0x000000010b26eb23 JSC::Interpreter::execute(JSC::ProgramExecutable*, JSC::ExecState*, JSC::ScopeChainNode*, JSC::JSObject*) + 2787 (Executable.h:416)
3   com.apple.JavaScriptCore      	0x000000010b1f63b8 JSC::evaluate(JSC::ExecState*, JSC::ScopeChainNode*, JSC::SourceCode const&, JSC::JSValue, JSC::JSValue*) + 344 (Completion.cpp:73)
4   com.apple.WebCore             	0x000000010c47eca1 WebCore::WorkerScriptController::evaluate(WebCore::ScriptSourceCode const&, WebCore::ScriptValue*) + 257 (Handle.h:70)
5   com.apple.WebCore             	0x000000010c47eabc WebCore::WorkerScriptController::evaluate(WebCore::ScriptSourceCode const&) + 60 (Handle.h:70)
6   com.apple.WebCore             	0x000000010c480689 WebCore::WorkerThread::workerThread() + 313 (ScriptSourceCode.h:45)
7   com.apple.JavaScriptCore      	0x000000010b3e820f _ZN3WTFL19wtfThreadEntryPointEPv + 15 (ThreadingPthreads.cpp:162)
8   libsystem_c.dylib             	0x00007fff85f5c8bf _pthread_start + 335
9   libsystem_c.dylib             	0x00007fff85f5fb75 thread_start + 13

Thread 12:: JavaScriptCore::Marking
0   libsystem_kernel.dylib        	0x00007fff8f2aebca __psynch_cvwait + 10
1   libsystem_c.dylib             	0x00007fff85f60274 _pthread_cond_wait + 840
2   com.apple.JavaScriptCore      	0x000000010b3034a4 JSC::SlotVisitor::drainFromShared(JSC::SlotVisitor::SharedDrainMode) + 212 (MarkStack.cpp:423)
3   com.apple.JavaScriptCore      	0x000000010b303386 JSC::MarkStackThreadSharedData::markingThreadMain() + 214 (MarkStack.cpp:226)
4   com.apple.JavaScriptCore      	0x000000010b3e820f _ZN3WTFL19wtfThreadEntryPointEPv + 15 (ThreadingPthreads.cpp:162)
5   libsystem_c.dylib             	0x00007fff85f5c8bf _pthread_start + 335
6   libsystem_c.dylib             	0x00007fff85f5fb75 thread_start + 13

Thread 13:: JavaScriptCore::Marking
0   libsystem_kernel.dylib        	0x00007fff8f2aebca __psynch_cvwait + 10
1   libsystem_c.dylib             	0x00007fff85f60274 _pthread_cond_wait + 840
2   com.apple.JavaScriptCore      	0x000000010b3034a4 JSC::SlotVisitor::drainFromShared(JSC::SlotVisitor::SharedDrainMode) + 212 (MarkStack.cpp:423)
3   com.apple.JavaScriptCore      	0x000000010b303386 JSC::MarkStackThreadSharedData::markingThreadMain() + 214 (MarkStack.cpp:226)
4   com.apple.JavaScriptCore      	0x000000010b3e820f _ZN3WTFL19wtfThreadEntryPointEPv + 15 (ThreadingPthreads.cpp:162)
5   libsystem_c.dylib             	0x00007fff85f5c8bf _pthread_start + 335
6   libsystem_c.dylib             	0x00007fff85f5fb75 thread_start + 13

Thread 14:: JavaScriptCore::Marking
0   libsystem_kernel.dylib        	0x00007fff8f2aebca __psynch_cvwait + 10
1   libsystem_c.dylib             	0x00007fff85f60274 _pthread_cond_wait + 840
2   com.apple.JavaScriptCore      	0x000000010b3034a4 JSC::SlotVisitor::drainFromShared(JSC::SlotVisitor::SharedDrainMode) + 212 (MarkStack.cpp:423)
3   com.apple.JavaScriptCore      	0x000000010b303386 JSC::MarkStackThreadSharedData::markingThreadMain() + 214 (MarkStack.cpp:226)
4   com.apple.JavaScriptCore      	0x000000010b3e820f _ZN3WTFL19wtfThreadEntryPointEPv + 15 (ThreadingPthreads.cpp:162)
5   libsystem_c.dylib             	0x00007fff85f5c8bf _pthread_start + 335
6   libsystem_c.dylib             	0x00007fff85f5fb75 thread_start + 13

Thread 15:: JavaScriptCore::BlockFree
0   libsystem_kernel.dylib        	0x00007fff8f2aebca __psynch_cvwait + 10
1   libsystem_c.dylib             	0x00007fff85f60274 _pthread_cond_wait + 840
2   com.apple.JavaScriptCore      	0x000000010b3e8816 WTF::ThreadCondition::timedWait(WTF::Mutex&, double) + 118 (ThreadingPthreads.cpp:415)
3   com.apple.JavaScriptCore      	0x000000010b26765f JSC::Heap::blockFreeingThreadMain() + 191 (Heap.cpp:399)
4   com.apple.JavaScriptCore      	0x000000010b3e820f _ZN3WTFL19wtfThreadEntryPointEPv + 15 (ThreadingPthreads.cpp:162)
5   libsystem_c.dylib             	0x00007fff85f5c8bf _pthread_start + 335
6   libsystem_c.dylib             	0x00007fff85f5fb75 thread_start + 13

Thread 11 crashed with X86 Thread State (64-bit):
  rax: 0x0000000000000000  rbx: 0x0000000000000000  rcx: 0x000000011275fed8  rdx: 0x000000011271fa60
  rdi: 0x000000011138de80  rsi: 0x0000000111394000  rbp: 0x00000001120cb8f0  rsp: 0x00000001120cacf0
   r8: 0x0000000000000000   r9: 0x0000000000000000  r10: 0x0000000111399000  r11: 0x00000001120cc400
  r12: 0x0000000000000000  r13: 0x000000011275fed8  r14: 0x0000000111394000  r15: 0x000000011275fe80
  rip: 0x000000010b260a6c  rfl: 0x0000000000010206  cr2: 0x0000000000000018
Logical CPU: 7

Binary Images:
       0x10b081000 -        0x10b0d8fff +DumpRenderTree (??? - ???) <7C545DE3-F44A-3363-8704-76CBE08E6B6F> /Volumes/VOLUME/*/DumpRenderTree
       0x10b187000 -        0x10b199ff7 +libWebCoreTestSupport.dylib (536.5.0 - compatibility 1.0.0) <A4C12DE4-AED4-3188-AF7D-8906A06E65B8> /Volumes/VOLUME/*/libWebCoreTestSupport.dylib
       0x10b1bf000 -        0x10b445fff  com.apple.JavaScriptCore (536+ - 536.5+) <4E62BD8F-5514-395F-BC54-CC59CAC0D47C> /Volumes/VOLUME/*/JavaScriptCore.framework/Versions/A/JavaScriptCore
       0x10b5ac000 -        0x10b730ff7  com.apple.WebKit (536+ - 536.5+) <90B54A74-3E15-3FBD-911B-AFACD738B75B> /Volumes/VOLUME/*/WebKit.framework/Versions/A/WebKit
       0x10b8c6000 -        0x10c867fff  com.apple.WebCore (536+ - 536.5+) <1E295F77-87A0-3124-B051-71174924C16B> /Volumes/VOLUME/*/WebCore.framework/Versions/A/WebCore
    0x7fff6ac81000 -     0x7fff6acb5baf  dyld (195.6 - ???) <0CD1B35B-A28F-32DA-B72E-452EAD609613> /usr/lib/dyld
    0x7fff847e7000 -     0x7fff847faff7  libCRFSuite.dylib (??? - ???) <0B76941F-218E-30C8-B6DE-E15919F8DBEB> /usr/lib/libCRFSuite.dylib
    0x7fff847fb000 -     0x7fff847fcfff  libunc.dylib (24.0.0 - compatibility 1.0.0) <337960EE-0A85-3DD0-A760-7134CF4C0AFF> /usr/lib/system/libunc.dylib
    0x7fff8498f000 -     0x7fff84990fff  liblangid.dylib (??? - ???) <CACBE3C3-2F7B-3EED-B50E-EDB73F473B77> /usr/lib/liblangid.dylib
    0x7fff84991000 -     0x7fff84992fff  libdnsinfo.dylib (395.10.0 - compatibility 1.0.0) <2301DE05-6950-3AFF-A8A6-DA76D4C079B5> /usr/lib/system/libdnsinfo.dylib
    0x7fff84993000 -     0x7fff84997ff7  com.apple.CommonPanels (1.2.5 - 94) <37C6540B-F8D1-355A-806C-F93D8FB522AB> /System/Library/Frameworks/Carbon.framework/Versions/A/Frameworks/CommonPanels.framework/Versions/A/CommonPanels
    0x7fff84adb000 -     0x7fff84adcfff  libDiagnosticMessagesClient.dylib (??? - ???) <3DCF577B-F126-302B-BCE2-4DB9A95B8598> /usr/lib/libDiagnosticMessagesClient.dylib
    0x7fff84b62000 -     0x7fff84b69ff7  com.apple.CommerceCore (1.0 - 17) <3894FE48-EDCE-30E9-9796-E2F959D92704> /System/Library/PrivateFrameworks/CommerceKit.framework/Versions/A/Frameworks/CommerceCore.framework/Versions/A/CommerceCore
    0x7fff84b98000 -     0x7fff84bdfff7  com.apple.CoreMedia (1.0 - 705.61) <0C34B0D4-DB8A-33C7-B67B-F443AD86482C> /System/Library/Frameworks/CoreMedia.framework/Versions/A/CoreMedia
    0x7fff84be0000 -     0x7fff84bf0ff7  com.apple.opengl (1.7.6 - 1.7.6) <C168883D-9BC5-3C38-9937-42852D719718> /System/Library/Frameworks/OpenGL.framework/Versions/A/OpenGL
    0x7fff84bf1000 -     0x7fff84c06fff  com.apple.speech.synthesis.framework (4.0.74 - 4.0.74) <C061ECBB-7061-3A43-8A18-90633F943295> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/SpeechSynthesis.framework/Versions/A/SpeechSynthesis
    0x7fff84f2b000 -     0x7fff84f2dff7  com.apple.print.framework.Print (7.1 - 247.1) <8A4925A5-BAA3-373C-9B5D-03E0270C6B12> /System/Library/Frameworks/Carbon.framework/Versions/A/Frameworks/Print.framework/Versions/A/Print
    0x7fff84f2e000 -     0x7fff84f40ff7  libz.1.dylib (1.2.5 - compatibility 1.0.0) <30CBEF15-4978-3DED-8629-7109880A19D4> /usr/lib/libz.1.dylib
    0x7fff84f88000 -     0x7fff84f8efff  com.apple.DiskArbitration (2.4.1 - 2.4.1) <CEA34337-63DE-302E-81AA-10D717E1F699> /System/Library/Frameworks/DiskArbitration.framework/Versions/A/DiskArbitration
    0x7fff85057000 -     0x7fff85164fff  libJP2.dylib (??? - ???) <F2B34A61-75F0-3BFE-A309-EE0DF4AF9E37> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ImageIO.framework/Versions/A/Resources/libJP2.dylib
    0x7fff85165000 -     0x7fff851e0ff7  com.apple.print.framework.PrintCore (7.1 - 366.1) <3F140DEB-9F87-3672-97CC-F983752581AC> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/PrintCore.framework/Versions/A/PrintCore
    0x7fff851e1000 -     0x7fff85249ff7  com.apple.audio.CoreAudio (4.0.2 - 4.0.2) <DFD8F4DE-3B45-3A2E-9CBE-FD8D5DD30923> /System/Library/Frameworks/CoreAudio.framework/Versions/A/CoreAudio
    0x7fff8524a000 -     0x7fff85250fff  IOSurface (??? - ???) <8114F62C-F75D-3123-99E9-268CB3AE74F7> /System/Library/Frameworks/IOSurface.framework/Versions/A/IOSurface
    0x7fff85251000 -     0x7fff85718fff  FaceCoreLight (1.4.7 - compatibility 1.0.0) <E9D2A69C-6E81-358C-A162-510969F91490> /System/Library/PrivateFrameworks/FaceCoreLight.framework/Versions/A/FaceCoreLight
    0x7fff85719000 -     0x7fff85719fff  com.apple.CoreServices (53 - 53) <043C8026-8EDD-3241-B090-F589E24062EF> /System/Library/Frameworks/CoreServices.framework/Versions/A/CoreServices
    0x7fff857d0000 -     0x7fff85853fef  com.apple.Metadata (10.7.0 - 627.28) <1C14033A-69C9-3757-B24D-5583AEAC2CBA> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/Metadata.framework/Versions/A/Metadata
    0x7fff85940000 -     0x7fff8594aff7  liblaunch.dylib (392.36.0 - compatibility 1.0.0) <CB8B5808-80C0-318E-AE12-96CA916442FE> /usr/lib/system/liblaunch.dylib
    0x7fff8594b000 -     0x7fff8599efff  com.apple.AppleVAFramework (5.0.14 - 5.0.14) <45159B9E-05BF-35B2-AF76-D933490FBFB1> /System/Library/PrivateFrameworks/AppleVA.framework/Versions/A/AppleVA
    0x7fff8599f000 -     0x7fff85a43fff  com.apple.ink.framework (1.3.2 - 110) <C8840EA4-AE7B-360C-A191-D36B5F10B6B5> /System/Library/Frameworks/Carbon.framework/Versions/A/Frameworks/Ink.framework/Versions/A/Ink
    0x7fff85a5a000 -     0x7fff85a6cff7  libbsm.0.dylib (??? - ???) <349BB16F-75FA-363F-8D98-7A9C3FA90A0D> /usr/lib/libbsm.0.dylib
    0x7fff85a6d000 -     0x7fff85a7afff  libCSync.A.dylib (600.0.0 - compatibility 64.0.0) <CBA71562-050B-3515-92B7-8BC1E2EEEF2A> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/CoreGraphics.framework/Versions/A/Resources/libCSync.A.dylib
    0x7fff85a7b000 -     0x7fff85a97ff7  com.apple.GenerationalStorage (1.0 - 126.1) <509F52ED-E54B-3FEF-B3C2-759387B826E6> /System/Library/PrivateFrameworks/GenerationalStorage.framework/Versions/A/GenerationalStorage
    0x7fff85a9b000 -     0x7fff85ac8ff7  com.apple.opencl (1.50.69 - 1.50.69) <687265AF-E9B6-3537-89D7-7C12EB38193D> /System/Library/Frameworks/OpenCL.framework/Versions/A/OpenCL
    0x7fff85ac9000 -     0x7fff85d3cfff  com.apple.CoreImage (7.93 - 1.0.1) <0B7D855E-A2B6-3C14-A242-2CF2165C6E7E> /System/Library/Frameworks/QuartzCore.framework/Versions/A/Frameworks/CoreImage.framework/Versions/A/CoreImage
    0x7fff85d3d000 -     0x7fff85e96fff  com.apple.audio.toolbox.AudioToolbox (1.7.2 - 1.7.2) <0AD8197C-1BA9-30CD-98F1-4CA2C6559BA8> /System/Library/Frameworks/AudioToolbox.framework/Versions/A/AudioToolbox
    0x7fff85eba000 -     0x7fff85ebffff  libGIF.dylib (??? - ???) <393E2DB5-9479-39A6-A75A-B5F20B852532> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ImageIO.framework/Versions/A/Resources/libGIF.dylib
    0x7fff85f0e000 -     0x7fff85febfef  libsystem_c.dylib (763.12.0 - compatibility 1.0.0) <FF69F06E-0904-3C08-A5EF-536FAFFFDC22> /usr/lib/system/libsystem_c.dylib
    0x7fff85fec000 -     0x7fff8641efef  com.apple.VideoToolbox (1.0 - 705.61) <1A70CA82-C849-3033-8598-37C5A72637CC> /System/Library/PrivateFrameworks/VideoToolbox.framework/Versions/A/VideoToolbox
    0x7fff8641f000 -     0x7fff8644fff7  com.apple.DictionaryServices (1.2.1 - 158.2) <3FC86118-7553-38F7-8916-B329D2E94476> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/DictionaryServices.framework/Versions/A/DictionaryServices
    0x7fff86451000 -     0x7fff86475fff  com.apple.Kerberos (1.0 - 1) <1F826BCE-DA8F-381D-9C4C-A36AA0EA1CB9> /System/Library/Frameworks/Kerberos.framework/Versions/A/Kerberos
    0x7fff86476000 -     0x7fff86479fff  com.apple.help (1.3.2 - 42) <BF14DE49-F7E8-336F-81FB-BBDF2DB3AC09> /System/Library/Frameworks/Carbon.framework/Versions/A/Frameworks/Help.framework/Versions/A/Help
    0x7fff8667f000 -     0x7fff86682fff  libCoreVMClient.dylib (??? - ???) <E034C772-4263-3F48-B083-25A758DD6228> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libCoreVMClient.dylib
    0x7fff86683000 -     0x7fff8678afe7  libsqlite3.dylib (9.6.0 - compatibility 9.0.0) <EE02BB01-64C9-304D-9719-A35F5CD6D04C> /usr/lib/libsqlite3.dylib
    0x7fff8678b000 -     0x7fff86790fff  libcache.dylib (47.0.0 - compatibility 1.0.0) <1571C3AB-BCB2-38CD-B3B2-C5FC3F927C6A> /usr/lib/system/libcache.dylib
    0x7fff8680b000 -     0x7fff8684afff  com.apple.AE (527.7 - 527.7) <B82F7ABC-AC8B-3507-B029-969DD5CA813D> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/AE.framework/Versions/A/AE
    0x7fff86850000 -     0x7fff86851ff7  libremovefile.dylib (21.1.0 - compatibility 1.0.0) <739E6C83-AA52-3C6C-A680-B37FE2888A04> /usr/lib/system/libremovefile.dylib
    0x7fff86852000 -     0x7fff86cb4ff7  com.apple.RawCamera.bundle (3.9.1 - 586) <1AA853F4-E429-33E3-B4A9-6B019CCCC5E4> /System/Library/CoreServices/RawCamera.bundle/Contents/MacOS/RawCamera
    0x7fff86cb5000 -     0x7fff86d25fff  com.apple.datadetectorscore (3.0 - 179.4) <B4C6417F-296C-31C1-BB94-980BFCDC9175> /System/Library/PrivateFrameworks/DataDetectorsCore.framework/Versions/A/DataDetectorsCore
    0x7fff86d26000 -     0x7fff86d28fff  libquarantine.dylib (36.2.0 - compatibility 1.0.0) <48656562-FF20-3B55-9F93-407ACA7341C0> /usr/lib/system/libquarantine.dylib
    0x7fff86d39000 -     0x7fff86d7bff7  libcommonCrypto.dylib (55010.0.0 - compatibility 1.0.0) <BB770C22-8C57-365A-8716-4A3C36AE7BFB> /usr/lib/system/libcommonCrypto.dylib
    0x7fff86d7c000 -     0x7fff87360fff  libBLAS.dylib (??? - ???) <C34F6D88-187F-33DC-8A68-C0C9D1FA36DF> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libBLAS.dylib
    0x7fff87361000 -     0x7fff873a4ff7  libRIP.A.dylib (600.0.0 - compatibility 64.0.0) <85D00F5C-43ED-33A9-80B4-72EB0EAE3E25> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/CoreGraphics.framework/Versions/A/Resources/libRIP.A.dylib
    0x7fff873a5000 -     0x7fff87447ff7  com.apple.securityfoundation (5.0 - 55107) <6C2E7362-CB11-3CBD-BB1C-348E4B10F25A> /System/Library/Frameworks/SecurityFoundation.framework/Versions/A/SecurityFoundation
    0x7fff874f8000 -     0x7fff874fffff  com.apple.NetFS (4.0 - 4.0) <433EEE54-E383-3505-9154-45B909FD3AF0> /System/Library/Frameworks/NetFS.framework/Versions/A/NetFS
    0x7fff87555000 -     0x7fff87574fff  libresolv.9.dylib (46.1.0 - compatibility 1.0.0) <0635C52D-DD53-3721-A488-4C6E95607A74> /usr/lib/libresolv.9.dylib
    0x7fff875d7000 -     0x7fff875edff7  com.apple.ImageCapture (7.0 - 7.0) <F15FC6FB-9E88-3BE9-BABE-0454D3A502A0> /System/Library/Frameworks/Carbon.framework/Versions/A/Frameworks/ImageCapture.framework/Versions/A/ImageCapture
    0x7fff87632000 -     0x7fff8765dff7  libxslt.1.dylib (3.24.0 - compatibility 3.0.0) <4DB5ED11-004B-36B5-AE5F-2AB714754241> /usr/lib/libxslt.1.dylib
    0x7fff8765e000 -     0x7fff876d4fff  com.apple.CoreSymbolication (2.2 - 73.2) <126415E3-3A35-315B-B4B7-507CDBED0D58> /System/Library/PrivateFrameworks/CoreSymbolication.framework/Versions/A/CoreSymbolication
    0x7fff8770b000 -     0x7fff87759fff  libauto.dylib (??? - ???) <D8AC8458-DDD0-3939-8B96-B6CED81613EF> /usr/lib/libauto.dylib
    0x7fff8775a000 -     0x7fff8780dfff  com.apple.CoreText (220.11.0 - ???) <0322442E-0530-37E8-A7D6-AEFD909F0AFE> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/CoreText.framework/Versions/A/CoreText
    0x7fff8780e000 -     0x7fff8780efff  com.apple.Accelerate (1.7 - Accelerate 1.7) <82DDF6F5-FBC3-323D-B71D-CF7ABC5CF568> /System/Library/Frameworks/Accelerate.framework/Versions/A/Accelerate
    0x7fff885cc000 -     0x7fff88650ff7  com.apple.ApplicationServices.ATS (317.5.0 - ???) <C2B254F0-6ED8-3313-9CFC-9ACD519C8A9E> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ATS.framework/Versions/A/ATS
    0x7fff8867d000 -     0x7fff886bcff7  libGLImage.dylib (??? - ???) <348729DC-BC44-3744-B249-9DFA6498344A> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGLImage.dylib
    0x7fff886bd000 -     0x7fff887bfff7  libxml2.2.dylib (10.3.0 - compatibility 10.0.0) <22F1D1B6-1761-3687-9EFD-036EA15FB2E4> /usr/lib/libxml2.2.dylib
    0x7fff887c0000 -     0x7fff887c2fff  libCVMSPluginSupport.dylib (??? - ???) <B2FC6EC0-1A0C-3482-A3C9-D08446E8713A> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libCVMSPluginSupport.dylib
    0x7fff8882e000 -     0x7fff8888efff  libvDSP.dylib (325.4.0 - compatibility 1.0.0) <3A7521E6-5510-3FA7-AB65-79693A7A5839> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libvDSP.dylib
    0x7fff888ed000 -     0x7fff8890aff7  com.apple.openscripting (1.3.3 - ???) <4FACC89E-FDAA-3CA5-B5CD-1F4EEAEDF7CF> /System/Library/Frameworks/Carbon.framework/Versions/A/Frameworks/OpenScripting.framework/Versions/A/OpenScripting
    0x7fff8890b000 -     0x7fff8891fff7  com.apple.LangAnalysis (1.7.0 - 1.7.0) <04C31EF0-912A-3004-A08F-CEC27030E0B2> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/LangAnalysis.framework/Versions/A/LangAnalysis
    0x7fff88920000 -     0x7fff88a2cfff  libcrypto.0.9.8.dylib (44.0.0 - compatibility 0.9.8) <3A8E1F89-5E26-3C8B-B538-81F5D61DBF8A> /usr/lib/libcrypto.0.9.8.dylib
    0x7fff88a2d000 -     0x7fff88a2dfff  libkeymgr.dylib (23.0.0 - compatibility 1.0.0) <61EFED6A-A407-301E-B454-CD18314F0075> /usr/lib/system/libkeymgr.dylib
    0x7fff88c79000 -     0x7fff88c84fff  com.apple.CommonAuth (2.1 - 2.0) <272CB600-6DA8-3952-97C0-5DC594DCA024> /System/Library/PrivateFrameworks/CommonAuth.framework/Versions/A/CommonAuth
    0x7fff88c87000 -     0x7fff88cfafff  libstdc++.6.dylib (52.0.0 - compatibility 7.0.0) <6BDD43E4-A4B1-379E-9ED5-8C713653DFF2> /usr/lib/libstdc++.6.dylib
    0x7fff88cfb000 -     0x7fff88cfbfff  com.apple.audio.units.AudioUnit (1.7.2 - 1.7.2) <04C10813-CCE5-3333-8C72-E8E35E417B3B> /System/Library/Frameworks/AudioUnit.framework/Versions/A/AudioUnit
    0x7fff88d49000 -     0x7fff88d69fff  libPng.dylib (??? - ???) <F4D84592-C450-3076-88E9-8E6517C7EF33> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ImageIO.framework/Versions/A/Resources/libPng.dylib
    0x7fff88d83000 -     0x7fff88dc4fff  com.apple.QD (3.40 - ???) <47674D2C-BE88-388E-B1B0-03F08BFFE5FD> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/QD.framework/Versions/A/QD
    0x7fff88dc5000 -     0x7fff88df2fe7  libSystem.B.dylib (159.1.0 - compatibility 1.0.0) <7BEBB139-50BB-3112-947A-F4AA168F991C> /usr/lib/libSystem.B.dylib
    0x7fff88e92000 -     0x7fff88e98fff  libmacho.dylib (800.0.0 - compatibility 1.0.0) <165514D7-1BFA-38EF-A151-676DCD21FB64> /usr/lib/system/libmacho.dylib
    0x7fff88ee0000 -     0x7fff88eedff7  libbz2.1.0.dylib (1.0.5 - compatibility 1.0.0) <3373D310-3B10-3DD1-B754-B7B138CD448D> /usr/lib/libbz2.1.0.dylib
    0x7fff88ef1000 -     0x7fff88ef1fff  com.apple.Carbon (153 - 153) <AF0F9910-E3C3-3922-AA92-A39000655E0F> /System/Library/Frameworks/Carbon.framework/Versions/A/Carbon
    0x7fff88ef2000 -     0x7fff88ef7fff  libcompiler_rt.dylib (6.0.0 - compatibility 1.0.0) <98ECD5F6-E85C-32A5-98CD-8911230CB66A> /usr/lib/system/libcompiler_rt.dylib
    0x7fff88f0a000 -     0x7fff88f12fff  libsystem_dnssd.dylib (??? - ???) <D0CEBE0E-956F-3CCF-9808-25FDEA42B9AF> /usr/lib/system/libsystem_dnssd.dylib
    0x7fff88f13000 -     0x7fff89115fff  libicucore.A.dylib (46.1.0 - compatibility 1.0.0) <38CD6ED3-C8E4-3CCD-89AC-9C3198803101> /usr/lib/libicucore.A.dylib
    0x7fff89140000 -     0x7fff89276fff  com.apple.vImage (5.1 - 5.1) <A08B7582-67BC-3EED-813A-4833645964A7> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vImage.framework/Versions/A/vImage
    0x7fff89277000 -     0x7fff89401ff7  com.apple.QTKit (7.7.1 - 2315) <BFC33B70-34F2-3940-A14A-3C51036589F0> /System/Library/Frameworks/QTKit.framework/Versions/A/QTKit
    0x7fff8962e000 -     0x7fff89947ff7  com.apple.Foundation (6.7.1 - 833.24) <6D4E6F93-64EF-3D41-AE80-2BB10E2E6323> /System/Library/Frameworks/Foundation.framework/Versions/C/Foundation
    0x7fff89948000 -     0x7fff8994eff7  libunwind.dylib (30.0.0 - compatibility 1.0.0) <1E9C6C8C-CBE8-3F4B-A5B5-E03E3AB53231> /usr/lib/system/libunwind.dylib
    0x7fff89cf5000 -     0x7fff89d45fff  com.apple.CoreMediaIO (210.0 - 3180) <C5B60D3E-71BE-3CD2-90FC-3B2F9961D662> /System/Library/Frameworks/CoreMediaIO.framework/Versions/A/CoreMediaIO
    0x7fff89d46000 -     0x7fff89de0ff7  com.apple.SearchKit (1.4.0 - 1.4.0) <4E70C394-773E-3A4B-A93C-59A88ABA9509> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/SearchKit.framework/Versions/A/SearchKit
    0x7fff89e1d000 -     0x7fff8a0fffff  com.apple.security (7.0 - 55110) <252F9E04-FF8A-3EA7-A38E-51DD0653663C> /System/Library/Frameworks/Security.framework/Versions/A/Security
    0x7fff8a100000 -     0x7fff8a104fff  libdyld.dylib (195.6.0 - compatibility 1.0.0) <FFC59565-64BD-3B37-90A4-E2C3A422CFC1> /usr/lib/system/libdyld.dylib
    0x7fff8a290000 -     0x7fff8a299ff7  libsystem_notify.dylib (80.1.0 - compatibility 1.0.0) <A4D651E3-D1C6-3934-AD49-7A104FD14596> /usr/lib/system/libsystem_notify.dylib
    0x7fff8a2f0000 -     0x7fff8aa84fef  com.apple.CoreAUC (6.11.04 - 6.11.04) <FFC336DF-C71F-3C93-8E93-5CBD9EEAE940> /System/Library/PrivateFrameworks/CoreAUC.framework/Versions/A/CoreAUC
    0x7fff8aa85000 -     0x7fff8aaadff7  com.apple.CoreVideo (1.7 - 70.1) <98F917B2-FB53-3EA3-B548-7E97B38309A7> /System/Library/Frameworks/CoreVideo.framework/Versions/A/CoreVideo
    0x7fff8aaae000 -     0x7fff8aae1ff7  com.apple.GSS (2.1 - 2.0) <57AD81CE-6320-38C9-9B66-0E5A4DEA898A> /System/Library/Frameworks/GSS.framework/Versions/A/GSS
    0x7fff8aae2000 -     0x7fff8aaf9fff  com.apple.CFOpenDirectory (10.7 - 146) <E6D4F114-678B-3957-9C59-9206ECDA756E> /System/Library/Frameworks/OpenDirectory.framework/Versions/A/Frameworks/CFOpenDirectory.framework/Versions/A/CFOpenDirectory
    0x7fff8aafa000 -     0x7fff8ab11fff  com.apple.MultitouchSupport.framework (220.62.1 - 220.62.1) <3F8C015B-88AC-370F-B39D-B4665FB7616A> /System/Library/PrivateFrameworks/MultitouchSupport.framework/Versions/A/MultitouchSupport
    0x7fff8ab12000 -     0x7fff8ab16fff  libmathCommon.A.dylib (2026.0.0 - compatibility 1.0.0) <FF83AFF7-42B2-306E-90AF-D539C51A4542> /usr/lib/system/libmathCommon.A.dylib
    0x7fff8ac68000 -     0x7fff8ac6efff  libGFXShared.dylib (??? - ???) <B95E9B22-AE68-3E48-8733-00CCCA08D50E> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGFXShared.dylib
    0x7fff8ac7b000 -     0x7fff8acc7ff7  com.apple.SystemConfiguration (1.11.2 - 1.11) <A14F3583-9CC0-397D-A50E-17217075953F> /System/Library/Frameworks/SystemConfiguration.framework/Versions/A/SystemConfiguration
    0x7fff8acf0000 -     0x7fff8ad48fff  libTIFF.dylib (??? - ???) <DD797FBE-9B63-3785-A9EA-0321D113538B> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ImageIO.framework/Versions/A/Resources/libTIFF.dylib
    0x7fff8ad49000 -     0x7fff8ad4dfff  libCGXType.A.dylib (600.0.0 - compatibility 64.0.0) <37517279-C92E-3217-B49A-838198B48787> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/CoreGraphics.framework/Versions/A/Resources/libCGXType.A.dylib
    0x7fff8adbe000 -     0x7fff8ae28ff7  com.apple.framework.IOKit (2.0 - ???) <EEEB42FD-E3E1-3A94-A771-B1993B694F17> /System/Library/Frameworks/IOKit.framework/Versions/A/IOKit
    0x7fff8ae29000 -     0x7fff8ae2aff7  libsystem_blocks.dylib (53.0.0 - compatibility 1.0.0) <8BCA214A-8992-34B2-A8B9-B74DEACA1869> /usr/lib/system/libsystem_blocks.dylib
    0x7fff8ae2b000 -     0x7fff8ae39fff  com.apple.NetAuth (3.2 - 3.2) <F0D60E34-37A9-308D-B44E-E3450906173A> /System/Library/PrivateFrameworks/NetAuth.framework/Versions/A/NetAuth
    0x7fff8ae66000 -     0x7fff8ae71ff7  libc++abi.dylib (14.0.0 - compatibility 1.0.0) <8FF3D766-D678-36F6-84AC-423C878E6D14> /usr/lib/libc++abi.dylib
    0x7fff8aebb000 -     0x7fff8aebdfff  com.apple.TrustEvaluationAgent (2.0 - 1) <1F31CAFF-C1C6-33D3-94E9-11B721761DDF> /System/Library/PrivateFrameworks/TrustEvaluationAgent.framework/Versions/A/TrustEvaluationAgent
    0x7fff8b4d1000 -     0x7fff8b50bfe7  com.apple.DebugSymbols (2.1 - 87) <E9000AB8-CCE4-3636-871D-E17703814B68> /System/Library/PrivateFrameworks/DebugSymbols.framework/Versions/A/DebugSymbols
    0x7fff8b554000 -     0x7fff8b5eaff7  libvMisc.dylib (325.4.0 - compatibility 1.0.0) <642D8D54-F9F5-3FBB-A96C-EEFE94C6278B> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libvMisc.dylib
    0x7fff8b5eb000 -     0x7fff8b62bff7  libcups.2.dylib (2.9.0 - compatibility 2.0.0) <29DE948E-38C4-3CC5-B528-40C691380607> /usr/lib/libcups.2.dylib
    0x7fff8b62c000 -     0x7fff8b62cfff  com.apple.vecLib (3.7 - vecLib 3.7) <9A58105C-B36E-35B5-812C-4ED693F2618F> /System/Library/Frameworks/vecLib.framework/Versions/A/vecLib
    0x7fff8b62d000 -     0x7fff8b654ff7  com.apple.PerformanceAnalysis (1.10 - 10) <DD87C994-66D6-330A-BAF9-AB86BE125A62> /System/Library/PrivateFrameworks/PerformanceAnalysis.framework/Versions/A/PerformanceAnalysis
    0x7fff8b655000 -     0x7fff8b66ffff  com.apple.CoreMediaAuthoring (2.0 - 890) <7BE57576-8EF5-3473-95E6-6191E239E3F0> /System/Library/PrivateFrameworks/CoreMediaAuthoring.framework/Versions/A/CoreMediaAuthoring
    0x7fff8b670000 -     0x7fff8b898fe7  com.apple.CoreData (104.1 - 358.13) <F1DA3110-C4DF-3F0A-A057-AEE78DE8C99D> /System/Library/Frameworks/CoreData.framework/Versions/A/CoreData
    0x7fff8b8b6000 -     0x7fff8b8dffff  libJPEG.dylib (??? - ???) <64D079F9-256A-323B-A837-84628B172F21> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ImageIO.framework/Versions/A/Resources/libJPEG.dylib
    0x7fff8b8e0000 -     0x7fff8b8e1ff7  libsystem_sandbox.dylib (??? - ???) <5087ADAD-D34D-3844-9D04-AFF93CED3D92> /usr/lib/system/libsystem_sandbox.dylib
    0x7fff8b9a4000 -     0x7fff8babdfff  com.apple.DesktopServices (1.6.2 - 1.6.2) <6B83172E-F539-3AF8-A76D-1F9EA357B076> /System/Library/PrivateFrameworks/DesktopServicesPriv.framework/Versions/A/DesktopServicesPriv
    0x7fff8babe000 -     0x7fff8bac1fff  libRadiance.dylib (??? - ???) <CD89D70D-F177-3BAE-8A26-644EA7D5E28E> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ImageIO.framework/Versions/A/Resources/libRadiance.dylib
    0x7fff8bac6000 -     0x7fff8bc2dff7  com.apple.CFNetwork (520.3.2 - 520.3.2) <516B611D-E53E-3467-9211-3C5B86ABA865> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/CFNetwork.framework/Versions/A/CFNetwork
    0x7fff8bca5000 -     0x7fff8bd87fff  com.apple.CoreServices.OSServices (478.37 - 478.37) <1DAC695E-0D0F-3AE2-974F-A173E69E67CC> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/OSServices.framework/Versions/A/OSServices
    0x7fff8be85000 -     0x7fff8c2b2fff  libLAPACK.dylib (??? - ???) <4F2E1055-2207-340B-BB45-E4F16171EE0D> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libLAPACK.dylib
    0x7fff8c2b3000 -     0x7fff8c307ff7  libFontRegistry.dylib (??? - ???) <F98926EF-FFA0-37C5-824C-02E436E21DD1> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ATS.framework/Versions/A/Resources/libFontRegistry.dylib
    0x7fff8c315000 -     0x7fff8c324ff7  libxar-nossl.dylib (??? - ???) <A6ABBFB9-E4ED-38AD-BBBB-F9958B9CEFB5> /usr/lib/libxar-nossl.dylib
    0x7fff8c325000 -     0x7fff8c325fff  com.apple.Cocoa (6.6 - ???) <7EC4D759-B2A6-3A99-AC75-809FED1500C6> /System/Library/Frameworks/Cocoa.framework/Versions/A/Cocoa
    0x7fff8cb2c000 -     0x7fff8cb3aff7  libkxld.dylib (??? - ???) <B779CF25-496C-31B0-B336-3E4E3E1C32CC> /usr/lib/system/libkxld.dylib
    0x7fff8cb3b000 -     0x7fff8cb40ff7  libsystem_network.dylib (??? - ???) <5DE7024E-1D2D-34A2-80F4-08326331A75B> /usr/lib/system/libsystem_network.dylib
    0x7fff8cb51000 -     0x7fff8cba5ff7  com.apple.ScalableUserInterface (1.0 - 1) <33563775-C662-313D-B7FA-3D575A9F3D41> /System/Library/Frameworks/QuartzCore.framework/Versions/A/Frameworks/ScalableUserInterface.framework/Versions/A/ScalableUserInterface
    0x7fff8cd83000 -     0x7fff8cddeff7  com.apple.HIServices (1.11 - ???) <DE8FA7FA-0A41-35D9-8473-5104F81DA934> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/HIServices.framework/Versions/A/HIServices
    0x7fff8cddf000 -     0x7fff8cde6fff  libcopyfile.dylib (85.1.0 - compatibility 1.0.0) <0AB51EE2-E914-358C-AC19-47BC024BDAE7> /usr/lib/system/libcopyfile.dylib
    0x7fff8cde7000 -     0x7fff8cdecfff  libpam.2.dylib (3.0.0 - compatibility 3.0.0) <D952F17B-200A-3A23-B9B2-7C1F7AC19189> /usr/lib/libpam.2.dylib
    0x7fff8cded000 -     0x7fff8cdfbfff  libdispatch.dylib (187.7.0 - compatibility 1.0.0) <712AAEAC-AD90-37F7-B71F-293FF8AE8723> /usr/lib/system/libdispatch.dylib
    0x7fff8ce8f000 -     0x7fff8ce8ffff  com.apple.ApplicationServices (41 - 41) <89B6AD5B-5C75-3E83-8C2B-AA7F4C55E400> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/ApplicationServices
    0x7fff8d5f6000 -     0x7fff8d648ff7  libGLU.dylib (??? - ???) <3C9153A0-8499-3DC0-AAA4-9FA6E488BE13> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGLU.dylib
    0x7fff8d649000 -     0x7fff8d965ff7  com.apple.CoreServices.CarbonCore (960.20 - 960.20) <C45CA09E-8867-3D67-BB2E-48D2E6B0D78C> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/CarbonCore.framework/Versions/A/CarbonCore
    0x7fff8dbdd000 -     0x7fff8dbe0ff7  com.apple.securityhi (4.0 - 1) <37DF1BF8-ACE0-3C4A-81AA-BBA9744EB0A6> /System/Library/Frameworks/Carbon.framework/Versions/A/Frameworks/SecurityHI.framework/Versions/A/SecurityHI
    0x7fff8dbe1000 -     0x7fff8e5717a7  com.apple.CoreGraphics (1.600.0 - ???) <177D9BAD-72C9-3ADF-A391-5B88C5EE623F> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/CoreGraphics.framework/Versions/A/CoreGraphics
    0x7fff8e572000 -     0x7fff8e57dff7  com.apple.speech.recognition.framework (4.0.19 - 4.0.19) <48607E6E-8612-3267-9184-E948B1863B32> /System/Library/Frameworks/Carbon.framework/Versions/A/Frameworks/SpeechRecognition.framework/Versions/A/SpeechRecognition
    0x7fff8e5a7000 -     0x7fff8e746fff  com.apple.QuartzCore (1.7 - 270.2) <F2CCDEFB-DE43-3E32-B242-A22C82617186> /System/Library/Frameworks/QuartzCore.framework/Versions/A/QuartzCore
    0x7fff8e9b6000 -     0x7fff8e9e1ff7  com.apple.CoreServicesInternal (113.12 - 113.12) <C37DAC1A-35D2-30EC-9112-5EEECED5C461> /System/Library/PrivateFrameworks/CoreServicesInternal.framework/Versions/A/CoreServicesInternal
    0x7fff8e9e2000 -     0x7fff8ea67ff7  com.apple.Heimdal (2.1 - 2.0) <3758B442-6175-32B8-8C17-D8ABDD589BF9> /System/Library/PrivateFrameworks/Heimdal.framework/Versions/A/Heimdal
    0x7fff8ea68000 -     0x7fff8ea8eff7  com.apple.framework.familycontrols (3.0 - 300) <DC06CF3A-2F10-3867-9498-CADAE30D0CE4> /System/Library/PrivateFrameworks/FamilyControls.framework/Versions/A/FamilyControls
    0x7fff8ea8f000 -     0x7fff8eacafff  libsystem_info.dylib (??? - ???) <35F90252-2AE1-32C5-8D34-782C614D9639> /usr/lib/system/libsystem_info.dylib
    0x7fff8ebaa000 -     0x7fff8ec0cff7  com.apple.Symbolication (1.3 - 91) <B072970E-9EC1-3495-A1FA-D344C6E74A13> /System/Library/PrivateFrameworks/Symbolication.framework/Versions/A/Symbolication
    0x7fff8ec0d000 -     0x7fff8ecf1e5f  libobjc.A.dylib (228.0.0 - compatibility 1.0.0) <871E688B-CF57-3BC7-80D6-F6476DFF109B> /usr/lib/libobjc.A.dylib
    0x7fff8ed0e000 -     0x7fff8edaefff  com.apple.LaunchServices (480.27.1 - 480.27.1) <4DC96C1E-6FDE-305E-9718-E4C5C1341F56> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/LaunchServices.framework/Versions/A/LaunchServices
    0x7fff8eded000 -     0x7fff8f18bfef  com.apple.MediaToolbox (1.0 - 705.61) <F48F2150-0573-354C-BBB2-BA52DD0FD0AB> /System/Library/PrivateFrameworks/MediaToolbox.framework/Versions/A/MediaToolbox
    0x7fff8f20b000 -     0x7fff8f210fff  com.apple.OpenDirectory (10.7 - 146) <A674AB55-6E3D-39AE-9F9B-9865D0193020> /System/Library/Frameworks/OpenDirectory.framework/Versions/A/OpenDirectory
    0x7fff8f211000 -     0x7fff8f286ff7  libc++.1.dylib (19.0.0 - compatibility 1.0.0) <C0EFFF1B-0FEB-3F99-BE54-506B35B555A9> /usr/lib/libc++.1.dylib
    0x7fff8f298000 -     0x7fff8f2b8fff  libsystem_kernel.dylib (1699.24.23 - compatibility 1.0.0) <80927C55-D4D9-31B6-9CF3-6134FCF1E1CA> /usr/lib/system/libsystem_kernel.dylib
    0x7fff8f646000 -     0x7fff8f70dff7  com.apple.ColorSync (4.7.1 - 4.7.1) <EA74B067-9916-341A-9C68-6165A4656042> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ColorSync.framework/Versions/A/ColorSync
    0x7fff8f72a000 -     0x7fff8f82ffff  libFontParser.dylib (??? - ???) <0920DA16-2066-33E6-BF95-AD4B0F3C22B0> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ATS.framework/Versions/A/Resources/libFontParser.dylib
    0x7fff8f83d000 -     0x7fff8f91bfff  com.apple.ImageIO.framework (3.1.1 - 3.1.1) <DB530A63-8ECF-3B53-AC9A-1692A5397E2F> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ImageIO.framework/Versions/A/ImageIO
    0x7fff8f91c000 -     0x7fff8fa19fff  com.apple.avfoundation (2.0 - 180.30) <061DDF4C-E7BB-33D0-BEB9-0443ADF6EC8C> /System/Library/Frameworks/AVFoundation.framework/Versions/A/AVFoundation
    0x7fff8ff3b000 -     0x7fff8ffa1ff7  com.apple.coreui (1.2.1 - 165.3) <378C9221-ADE6-36D9-9944-F33AE6904E4F> /System/Library/PrivateFrameworks/CoreUI.framework/Versions/A/CoreUI
    0x7fff8ffa2000 -     0x7fff8ffa2fff  com.apple.Accelerate.vecLib (3.7 - vecLib 3.7) <C06A140F-6114-3B8B-B080-E509303145B8> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/vecLib
    0x7fff8ffa7000 -     0x7fff8ffc4fff  libxpc.dylib (77.18.0 - compatibility 1.0.0) <26C05F31-E809-3B47-AF42-1460971E3AC3> /usr/lib/system/libxpc.dylib
    0x7fff8ffc5000 -     0x7fff900bafff  libiconv.2.dylib (7.0.0 - compatibility 7.0.0) <5C40E880-0706-378F-B864-3C2BD922D926> /usr/lib/libiconv.2.dylib
    0x7fff900bb000 -     0x7fff9028ffff  com.apple.CoreFoundation (6.7.1 - 635.19) <57B77925-9065-38C9-A05B-02F4F9ED007C> /System/Library/Frameworks/CoreFoundation.framework/Versions/A/CoreFoundation
    0x7fff90290000 -     0x7fff902b4fff  com.apple.RemoteViewServices (1.3 - 44) <21D7A0E7-6699-37AB-AE6C-BF69AF3D61C2> /System/Library/PrivateFrameworks/RemoteViewServices.framework/Versions/A/RemoteViewServices
    0x7fff902b5000 -     0x7fff905dfff7  com.apple.HIToolbox (1.8 - ???) <D6A0D513-4893-35B4-9FFE-865FF419F2C2> /System/Library/Frameworks/Carbon.framework/Versions/A/Frameworks/HIToolbox.framework/Versions/A/HIToolbox
    0x7fff90a74000 -     0x7fff91678fff  com.apple.AppKit (6.7.3 - 1138.32) <A9EB81C6-C519-3F29-89F1-42C3E8930281> /System/Library/Frameworks/AppKit.framework/Versions/C/AppKit
    0x7fff91679000 -     0x7fff9168ffff  libGL.dylib (??? - ???) <6A473BF9-4D35-34C6-9F8B-86B68091A9AF> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib

External Modification Summary:
  Calls made by other processes targeting this process:
    task_for_pid: 2
    thread_create: 0
    thread_set_state: 0
  Calls made by this process:
    task_for_pid: 0
    thread_create: 0
    thread_set_state: 0
  Calls made by all processes on this machine:
    task_for_pid: 644912
    thread_create: 0
    thread_set_state: 0

VM Region Summary:
ReadOnly portion of Libraries: Total=204.2M resident=107.7M(53%) swapped_out_or_unallocated=96.4M(47%)
Writable regions: Total=1.1G written=11.9M(1%) resident=15.3M(1%) swapped_out=0K(0%) unallocated=1.1G(99%)
 
REGION TYPE                        VIRTUAL
===========                        =======
CG backing stores                    1888K
CG image                             1876K
CG raster data                         64K
CG shared images                     1216K
CoreGraphics                           16K
CoreServices                          788K
JS JIT generated code               128.0M
JS JIT generated code (reserved)    896.0M        reserved VM address space (unallocated)
JS VM register file                  4096K
JS VM register file (reserved)       4096K        reserved VM address space (unallocated)
JS garbage collector                 1280K
MALLOC                               74.1M
MALLOC guard page                      48K
Memory tag=251                         16K
SQLite page cache                     384K
STACK GUARD                          56.1M
Stack                                15.6M
VM_ALLOCATE                          16.2M
__CI_BITMAP                            80K
__DATA                               17.1M
__IMAGE                               528K
__LINKEDIT                           67.4M
__RC_CAMERAS                          232K
__TEXT                              136.8M
__UNICODE                             544K
mapped file                          34.9M
shared memory                         308K
===========                        =======
TOTAL                                 1.4G
TOTAL, minus reserved VM space      559.2M
Comment 1 Radar WebKit Bug Importer 2012-03-29 16:09:41 PDT
<rdar://problem/11151176>
Comment 2 Michael Saboff 2012-03-30 11:20:20 PDT
Created attachment 134844 [details]
Patch
Comment 3 Alexey Proskuryakov 2012-03-30 11:30:13 PDT
Comment on attachment 134844 [details]
Patch

I feel like I've seen this patch before, and we decided that this was the wrong way to deal with empty source code. Is that not the case?
Comment 4 Alexey Proskuryakov 2012-03-30 11:33:09 PDT
Found it - the discussion was in bug 77593.
Comment 5 Michael Saboff 2012-03-30 11:44:48 PDT
(In reply to comment #4)
> Found it - the discussion was in bug 77593.

I believe that bug 77593 handles the Null string case.  This bug is to handle the empty string.  Per our discussion, I will check to make sure that the normal script controller as well as the worker script controller both handle null and empty string the same.
Comment 6 Geoffrey Garen 2012-03-30 12:15:23 PDT
My understanding is that the empty string is intended to be a valid zero-length string, and all interfaces should accept it, while the NULL string is like a NULL pointer, it means "unspecified" or "uninitialized", and some interfaces accept it while some don't.

If this understanding is true, it's definitely wrong to require clients of JavaScriptCore to short-circuit and avoid passing the empty string to the interpreter. As I've said in person, there are many ways a client could pass us the empty string, including through API. Changing this one place to paper over the problem is wrong.

If this understanding is true, the fix in bug 77593 is also wrong: The result of executing an "unspecified" or "uninitialized" string as JavaScript is unknown, and it's likely that any client passing us such a thing has made a programming error.
Comment 7 Benjamin Poulain 2012-03-30 12:37:42 PDT
> If this understanding is true, the fix in bug 77593 is also wrong: The result of executing an "unspecified" or "uninitialized" string as JavaScript is unknown, and it's likely that any client passing us such a thing has made a programming error.

I do not disagree regarding 77593. I needed a quick fix so we reverted to the behavior existing before is8Bit() was added.

What you suggest would require more work but I think it is right.
Comment 8 Michael Saboff 2012-04-02 15:07:15 PDT
Created attachment 135202 [details]
Updated patch

It turns out that isEmpty() works because it was checking both Null and empty.  The issue we have here is the Null case.  This patch uses a Null check in the caller to WorkerScriptController::evaluate() instead of having the isEmpty() check there.
Comment 9 Benjamin Poulain 2012-04-02 17:31:29 PDT
Comment on attachment 135202 [details]
Updated patch

View in context: https://bugs.webkit.org/attachment.cgi?id=135202&action=review

> Source/WebCore/workers/WorkerThread.cpp:153
> -    script->evaluate(ScriptSourceCode(m_startupData->m_sourceCode, m_startupData->m_scriptURL));
> +    if (!m_startupData->m_sourceCode.isNull())
> +        script->evaluate(ScriptSourceCode(m_startupData->m_sourceCode, m_startupData->m_scriptURL));

With this, what will show up in the Inspector? My concern is it would show something fake starting for the current context instead of ignoring the previous context.
Comment 10 Benjamin Poulain 2012-04-02 17:31:30 PDT
Comment on attachment 135202 [details]
Updated patch

View in context: https://bugs.webkit.org/attachment.cgi?id=135202&action=review

> Source/WebCore/workers/WorkerThread.cpp:153
> -    script->evaluate(ScriptSourceCode(m_startupData->m_sourceCode, m_startupData->m_scriptURL));
> +    if (!m_startupData->m_sourceCode.isNull())
> +        script->evaluate(ScriptSourceCode(m_startupData->m_sourceCode, m_startupData->m_scriptURL));

With this, what will show up in the Inspector? My concern is it would show something fake starting for the current context instead of ignoring the previous context.
Comment 11 Geoffrey Garen 2012-04-02 19:06:46 PDT
Comment on attachment 135202 [details]
Updated patch

View in context: https://bugs.webkit.org/attachment.cgi?id=135202&action=review

>>> Source/WebCore/workers/WorkerThread.cpp:153
>>> +    if (!m_startupData->m_sourceCode.isNull())
>>> +        script->evaluate(ScriptSourceCode(m_startupData->m_sourceCode, m_startupData->m_scriptURL));
>> 
>> With this, what will show up in the Inspector? My concern is it would show something fake starting for the current context instead of ignoring the previous context.
> 
> With this, what will show up in the Inspector? My concern is it would show something fake starting for the current context instead of ignoring the previous context.

A better bottleneck for the NULL check is Worker::notifyFinished(). We should never start a worker thread with a NULL script. Once the worker has started, it should be able to assume that it has valid JavaScript to execute.

Do you know why we end up with a NULL script and yet Worker::m_scriptLoader doesn't report that it failed to load?
Comment 12 Benjamin Poulain 2012-04-02 23:26:00 PDT
> A better bottleneck for the NULL check is Worker::notifyFinished(). We should never start a worker thread with a NULL script. Once the worker has started, it should be able to assume that it has valid JavaScript to execute.
> 
> Do you know why we end up with a NULL script and yet Worker::m_scriptLoader doesn't report that it failed to load?

The common case I have seen goes like this:
1) page A schedule a thread
2) scripts change to page B
3) thread start on page B
-->loaded was invalidated, source is now null

I am sure there are other ways to invalidate the source, it is just what I have experienced.
Comment 13 Michael Saboff 2012-04-03 11:02:04 PDT
Created attachment 135365 [details]
Updated Patch

> Do you know why we end up with a NULL script and yet Worker::m_scriptLoader doesn't report that it failed to load?

WorkerScriptLoader::didReceiveData() allows for a null script to not be an error.

It appears that the tests are checking the NULL case directly.
Comment 14 Michael Saboff 2012-04-03 13:35:06 PDT
Created attachment 135410 [details]
Final Patch

Updated patch that initializes m_script to an empty string so that even when no input is given, it will be processed as an empty string.

Reviewed in person by Geoff Garen.
Comment 15 Michael Saboff 2012-04-03 13:41:03 PDT
Committed r113082: <http://trac.webkit.org/changeset/113082>